//
//
//                                Assert Header
//
//   Copyright (c) 1994-1999 by Dan Higdon, Tim Little, and Chuck Walbourn
//
//
//
// This file and all associated files are subject to the terms of the
// GNU Lesser General Public License version 2 as published by the
// Free Software Foundation (http://www.gnu.org).   They remain the
// property of the authors: Dan Higdon, Tim Little, and Chuck Walbourn.
// See LICENSE.TXT in the distribution for a copy of this license.
//
// THE AUTHORS MAKE NO WARRANTIES, EXPRESS OR IMPLIED, AS TO THE CORRECTNESS
// OF THIS CODE OR ANY DERIVATIVE WORKS WHICH INCORPORATE IT.  THE AUTHORS
// PROVIDE THE CODE ON AN "AS-IS" BASIS AND EXPLICITLY DISCLAIMS ANY
// LIABILITY, INCLUDING CONSEQUENTIAL AND INCIDENTAL DAMAGES FOR ERRORS,
// OMISSIONS, AND OTHER PROBLEMS IN THE CODE.
//
//
//
//                        http://www.mythos-engine.org/
//
//
//
// Windows assert replacement.
//
//


#ifndef __CHARYBDIS_ASSERT
#define __CHARYBDIS_ASSERT 1

//
//
//                                Equates
//
//

#undef  assert
#undef  assertMyth

#ifdef NDEBUG
#define assert(exp)     ((void)0)
#define assertMyth(msg,exp)     ((void)0)
#else

#ifdef __cplusplus
extern "C"
#endif
void _charybdis_assert(char *txt, char *exp, char *f, unsigned ln);

#define assert(exp) (void)( (exp) || (_charybdis_assert(0, #exp, __FILE__, __LINE__), 0)  )
#define assertMyth(msg,exp) (void)( (exp) || (_charybdis_assert(msg, #exp, __FILE__, __LINE__), 0)  )

#endif

#endif

// End of header - assert.h 
