//
//
//
//
//
//
//
//
//
//
// Microsoft Windows 95/98/NT Version 
//
//Copyright (c) 1994-1999 by Dan Higdon, Tim Little, and Chuck Walbourn
//
//
//
// This file and all associated files are subject to the terms of the
// GNU Lesser General Public License version 2 as published by the
// Free Software Foundation (http://www.gnu.org).   They remain the
// property of the authors: Dan Higdon, Tim Little, and Chuck Walbourn.
// See LICENSE.TXT in the distribution for a copy of this license.
//
// THE AUTHORS MAKE NO WARRANTIES, EXPRESS OR IMPLIED, AS TO THE CORRECTNESS
// OF THIS CODE OR ANY DERIVATIVE WORKS WHICH INCORPORATE IT.  THE AUTHORS
// PROVIDE THE CODE ON AN "AS-IS" BASIS AND EXPLICITLY DISCLAIMS ANY
// LIABILITY, INCLUDING CONSEQUENTIAL AND INCIDENTAL DAMAGES FOR ERRORS,
// OMISSIONS, AND OTHER PROBLEMS IN THE CODE.
//
//
//
//                        http://www.mythos-engine.org/
//
//
//
// Created by Tim Little & Chuck Walbourn
//
//                       *** IPAS Mesh Data Exporter ***
//
// client.c
//
//  PXP process skeleton code
//
//  (C) Copyright 1994 by Autodesk, Inc.
//
//  This program is copyrighted by Autodesk, Inc. and is licensed to you under
//  the following conditions.  You may not distribute or publish the source
//  code of this program in any form.  You may incorporate this code in object
//  form in derivative works provided such derivative works are (i.) are de-
//  signed and intended to work solely with Autodesk, Inc. products, and (ii.)
//  contain Autodesk's copyright notice "(C) Copyright 1994 by Autodesk, Inc."
//
//  AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.  AUTODESK SPE-
//  CIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR
//  A PARTICULAR USE.  AUTODESK, INC.  DOES NOT WARRANT THAT THE OPERATION OF
//  THE PROGRAM WILL BE UNINTERRUPTED OR ERROR FREE.
//
//

#pragma off(unreferenced);

//
//
//                                Includes
//
//

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#include "debug.h"

#include "pxp.h"

//
//
//                                Equates
//
//

#define VERSION 0x0100

//
//
//                               Structures
//
//

typedef struct
{
   ulong version;
} State;

//
//
//                               Routines
//
//

void do_user_interaction();

//
//
//                                 Data
//
//

/* Dialog description */

DlgEntry cdialog[]=
{
   0, NULL
};

/* the "state" struct MUST start with a "ulong" which is the version#,
   to prevent using data from old versions of this program.
   This verification is performed automatically. */

STATIC State init_state = { VERSION };
STATIC State state = { VERSION };

//
//
//                                 Code
//
//

//Ŀ
//                                                                          
//
int ClientUsesInitDialog(void)
{
   return 0;
}

DlgEntry *ClientDialog(int n)
{
   return(&cdialog[n]);
}


//Ŀ
//                                                                          
//
void ClientSetStateVar(int id, void *ptr)
{
   OVL o;
   ulong *ul;
   char *s;

   ul=(ulong *)ptr;
   s=(char *)ptr;
   o.ul = *ul;
//   switch(id)
//   {
//   }
}

ulong ClientGetStateVar(int id)
{
   OVL o;
//   switch(id)
//   {
//   }
   return(o.ul);
}

int ClientVarSize(int id)
{
//   switch(id)
//   {
//   default:
      return(1);
//   }
}

char  *ClientGetState(int *size)
{
   *size = sizeof(State);
   return((char *)&state);
}

void ClientResetState()
{
   state = init_state;
}


//Ŀ
//                                                                          
//
/* This function should return 1 if the PXP can function in any
   module, otherwise, it should return 0.  */

int ClientIsUniversal(void)
{
   return(0);
}

void ClientStartup(EXPbuf *buf)
{
   int version=studio_version();

   if(version<400)
   {
       strcpy(buf->data.string, "ERROR: Requires 3DS version 4.0 or greater");
       buf->opcode=EXP_CONTINUE;
       buf->usercode=EXP_TERMINATE;
   }
   else
   {
       buf->opcode=EXP_NOP;
       buf->usercode=0x0200;
   }
}

void ClientTerminate(void)
{
   /* free any data structures, etc. */
}


//Ŀ
//                                                                          
//
void ClientUserCode(EXPbuf *buf)
{
   switch(buf->usercode)
   {
       case 0x0200:
           do_user_interaction();
           buf->opcode=EXP_TERMINATE;
           buf->usercode=EXP_TERMINATE;
           break;
       default:
           buf->opcode=buf->usercode=EXP_TERMINATE;
           buf->status=0;
           break;
   }
}

// End of module - client.c 

