;
;
;
;            _,'|             _.-''``-...___..--';)
;           /_ \'.      __..-' ,      ,--...--'''
;          <\    .`--'''       `     /'
;           `-';'               ;   ; ;  Felix the Fixed-point Library
;     __...--''     ___...--_..'  .;.'
;    (,__....----'''       (,..--''
;
;                    Microsoft Windows 95/98/NT Version
;
;  Copyright (c) 1994-1999 by Dan Higdon, Tim Little, and Chuck Walbourn
;
;
;
; This file and all associated files are subject to the terms of the
; GNU Lesser General Public License version 2 as published by the
; Free Software Foundation (http://www.gnu.org).   They remain the
; property of the authors: Dan Higdon, Tim Little, and Chuck Walbourn.
; See LICENSE.TXT in the distribution for a copy of this license.
;
; THE AUTHORS MAKE NO WARRANTIES, EXPRESS OR IMPLIED, AS TO THE CORRECTNESS
; OF THIS CODE OR ANY DERIVATIVE WORKS WHICH INCORPORATE IT.  THE AUTHORS
; PROVIDE THE CODE ON AN "AS-IS" BASIS AND EXPLICITLY DISCLAIMS ANY
; LIABILITY, INCLUDING CONSEQUENTIAL AND INCIDENTAL DAMAGES FOR ERRORS,
; OMISSIONS, AND OTHER PROBLEMS IN THE CODE.
;
;
;
;                        http://www.mythos-engine.org/
;
;
;
; Created by Tim Little
;
;  felix.inc
;
;      Includes for the Felix fixed point library.
;
;

ifndef __FELIX_INC
__FELIX_INC    equ 1

;
;
;                                Includes
;
;

;
;
;                                Equates
;
;

SAFE_DIVIDE             equ     1


FLX16_ONE               equ     010000h ; this is one in 16.16
FLX_SQRT_BITRES         equ     0ch     ; number of bits resolution in SQRT
                                        ; table.
FLX_DEGREES_SHIFT       equ     6       ; number of bits resolution in SIN
                                        ; table, (ie. 1/64th of a degrees).

FLX16_SHIFTS            equ     16      ; this is the shift value for 16.16s


;
;
;                                Externs
;
;

;Data Externs
EXTRN   Flx16_sin_data:NEAR
EXTRN   Flx16_sqrt_table:NEAR

;
;
;                                Macros
;
;

;
;
;                               Structures
;
;
endif          ; __FELIX_INC

; End of module - felix.inc 

