//
//
//                              S I M   G I N E
//
//             __               ___   ______,-------
//           __==__,------------/|\--|      | .-.-.|    ___________
//         (|     |--------------|---|------| '-`-`|  _/___________\_
//         (|_____|      _       _   |   _  | 6000 | |               |
//          |__\\_|`-._/___\___/___\_|_/___\|      | |               |
//         __/ |===|--|_____|_|_____|_|___  |\_____|=|_______________|
//      |=|[_]==[_]    \ _ /   \ _ /   \ _ /          [_]   [_]   [_]
//
//
//                     A Simluator Framework for MythOS(tm)
//
//                     Microsoft Windows 95/98/NT Version
//
//  Copyright (c) 1997-1999 by Dan Higdon, Tim Little, and Chuck Walbourn
//
//
//
// This file and all associated files are subject to the terms of the
// GNU Lesser General Public License version 2 as published by the
// Free Software Foundation (http://www.gnu.org).   They remain the
// property of the authors: Dan Higdon, Tim Little, and Chuck Walbourn.
// See LICENSE.TXT in the distribution for a copy of this license.
//
// THE AUTHORS MAKE NO WARRANTIES, EXPRESS OR IMPLIED, AS TO THE CORRECTNESS
// OF THIS CODE OR ANY DERIVATIVE WORKS WHICH INCORPORATE IT.  THE AUTHORS
// PROVIDE THE CODE ON AN "AS-IS" BASIS AND EXPLICITLY DISCLAIMS ANY
// LIABILITY, INCLUDING CONSEQUENTIAL AND INCIDENTAL DAMAGES FOR ERRORS,
// OMISSIONS, AND OTHER PROBLEMS IN THE CODE.
//
//
//
//                        http://www.mythos-engine.org/
//
//
//
// Created by Dan Higdon and Chuck Walbourn
//
// simbase.cpp
//
// This module contains the base representation class for the simulator.
//
//

//
//
//                                Includes
//
//

#include "simgine.hpp"

//
//
//                                 Code
//
//

//
//  Constructors/Destructors  
//

//
// SimBase - Constructor
//
SimBase::SimBase(SimulatorState *_parent) :
    base_flags(0),
    parent(_parent),
    index(ushort(-1)),
    team(SIM_TEAM_GRAY)
{
    assertMyth("SimBase needs valid parent", _parent != 0);

    *name = 0;
}


//
// SimBase - Destructor
//
SimBase::~SimBase()
{
    release();
}



//
//  Operations  
//

//
// SimBase - release
//
void SimBase::release()
{
}


//
// SimBase - step
//
void SimBase::step(float interval)
{
}


//
// SimBase - get_position
//
void SimBase::get_position(EschPoint &pos) const
{
}


//
// SimBase - set_position
//
void SimBase::set_position(EschPoint &pos)
{
}



//
//  Utility Routines  
//

// End of module - simbase.cpp 

